View Issue Details

IDProjectCategoryView StatusLast Update
0002607Far ManagerPlugins API.Dialogpublic2014-02-28 01:47
ReportershmuelAssigned Tovskirdin 
PrioritynormalSeveritycrashReproducibilityalways
Status assignedResolutionfixed 
Platformx86OSWindowsOS VersionXP SP3
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0002607: DM_SETITEMPOSITION вызывает падение Фара, если Right < Left - 1
DescriptionПроисходит падение, как изображено на картинке.
Steps To Reproduce-- исполнить следующий скрипт

local function DlgProc (hDlg, msg, param1, param2)
  if msg == far.Flags.DN_INITDIALOG then
    far.SendDlgMessage(hDlg, "DM_SETITEMPOSITION", 1, {Left=5, Right=2})
  end
end

local items = {{"DI_EDIT",1,3,10,3, 0,0,0,0,"text"}}
far.Dialog ("",-1,-1,40,10,nil,items,0,DlgProc)
TagsNo tags attached.
Build3817

Activities

shmuel

2014-02-20 19:12

developer  

Pic1.png (1,496 bytes)
Pic1.png (1,496 bytes)

vskirdin

2014-02-20 21:36

administrator   bugnote:0011844

build 3815

DrKnS

2014-02-20 22:27

administrator   bugnote:0011845

А зачем их в таком случае свапать, а не просто return false?

Параметры же явно некорректны.

vskirdin

2014-02-20 22:57

administrator   bugnote:0011846

...ну или так.

2useven10

2014-02-21 14:21

developer   bugnote:0011847

{Left=-2, Right=-5} -- падаем

vskirdin

2014-02-21 15:55

administrator   bugnote:0011848

Напомните... у DM_SETITEMPOSITION вроде не должно быть отрицательных значений.
?

2useven10

2014-02-21 16:04

developer   bugnote:0011849

Падать не должно.
А кто будет проверять корректность X3.

vskirdin

2014-02-21 16:07

administrator   bugnote:0011850

Не, left и top могут быть == -1.

vskirdin

2014-02-21 16:30

administrator   bugnote:0011851

походу надо переписать
bool Dialog::SetItemRect(DialogItemEx& Item, const SMALL_RECT& Rect)
после праздников :-)

shmuel

2014-02-21 21:06

developer   bugnote:0011852

3817.

vskirdin

2014-02-27 14:14

administrator   bugnote:0011858

far.SendDlgMessage(hDlg, "DM_SETITEMPOSITION", 1, {Left=-10, Right=-2})
падения нет, но и показывает вне диалога

shmuel

2014-02-28 01:47

developer   bugnote:0011859

@vskirdin
Я закрыл тикет, потому что объявленная в его заголовке проблема (падение Фара) разрешена. То, что показывает вне диалога, это уже другая проблема, гораздо меньшая. На мой взгляд, править это необязательно. Можно, но не обязательно. Если у тебя есть желание - правь.

Issue History

Date Modified Username Field Change
2014-02-20 19:11 shmuel New Issue
2014-02-20 19:12 shmuel File Added: Pic1.png
2014-02-20 19:18 shmuel Steps to Reproduce Updated View Revisions
2014-02-20 21:36 vskirdin Note Added: 0011844
2014-02-20 21:36 vskirdin Assigned To => vskirdin
2014-02-20 21:36 vskirdin Status new => feedback
2014-02-20 22:27 DrKnS Note Added: 0011845
2014-02-20 22:57 vskirdin Note Added: 0011846
2014-02-21 01:06 shmuel Build => 3815
2014-02-21 01:06 shmuel Status feedback => closed
2014-02-21 01:06 shmuel Resolution open => fixed
2014-02-21 01:06 shmuel Fixed in Version => 3.0
2014-02-21 14:21 2useven10 Note Added: 0011847
2014-02-21 14:22 2useven10 Status closed => assigned
2014-02-21 15:55 vskirdin Note Added: 0011848
2014-02-21 16:04 2useven10 Note Added: 0011849
2014-02-21 16:07 vskirdin Note Added: 0011850
2014-02-21 16:30 vskirdin Note Added: 0011851
2014-02-21 21:06 shmuel Note Added: 0011852
2014-02-21 21:06 shmuel Status assigned => feedback
2014-02-21 22:52 2useven10 Status feedback => resolved
2014-02-21 23:09 shmuel Build 3815 => 3817
2014-02-21 23:09 shmuel Status resolved => closed
2014-02-27 14:14 vskirdin Note Added: 0011858
2014-02-27 14:14 vskirdin Status closed => assigned
2014-02-28 01:47 shmuel Note Added: 0011859